
/* Chrysalide - Outil d'analyse de fichiers binaires
 * pattern-int.h - prototypes internes pour la définition de motif à rechercher
 *
 * Copyright (C) 2022 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_PATTERN_INT_H
#define _ANALYSIS_SCAN_PATTERN_INT_H


#include "pattern.h"



/* Décompte le nombre de correspondances identifiées. */
typedef size_t (* count_pattern_matchs_fc) (const GSearchPattern *);


/* Motif à rechercher au sein d'un contenu (instance) */
struct _GSearchPattern
{
    GObject parent;                         /* A laisser en premier        */

    char *name;                             /* Eventuelle désignation      */

};

/* Motif à rechercher au sein d'un contenu (classe) */
struct _GSearchPatternClass
{
    GObjectClass parent;                    /* A laisser en premier        */

    count_pattern_matchs_fc count;          /* Décompte des résultats      */

};



#endif  /* _ANALYSIS_SCAN_PATTERN_INT_H */
